VERSION 4.00
Begin VB.Form Frm_View 
   AutoRedraw      =   -1  'True
   Caption         =   "Picture Viewer (c) 1997 by Ralf Rei"
   ClientHeight    =   4065
   ClientLeft      =   1680
   ClientTop       =   1665
   ClientWidth     =   9285
   FillStyle       =   0  'Solid
   BeginProperty Font 
      name            =   "MS Sans Serif"
      charset         =   0
      weight          =   700
      size            =   8.25
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4755
   Icon            =   "FRM_VIEW.frx":0000
   Left            =   1620
   LinkTopic       =   "Form1"
   ScaleHeight     =   271
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   619
   Top             =   1035
   Width           =   9405
   Begin VB.CommandButton Btn_SaveAs 
      Caption         =   "&save as"
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   400
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   8340
      TabIndex        =   8
      Top             =   3300
      Width           =   915
   End
   Begin VB.CommandButton Btn_Delete 
      Caption         =   "&lschen"
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   400
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   7380
      TabIndex        =   7
      Top             =   3300
      Width           =   915
   End
   Begin VB.DriveListBox DriveBox 
      Height          =   315
      Left            =   4260
      TabIndex        =   4
      Top             =   3300
      Width           =   1995
   End
   Begin VB.FileListBox FileBox 
      Height          =   3180
      Left            =   4260
      Pattern         =   "*.BMP;*.WMF;*.ICO;*.PCX;*.GIF;*.JPG"
      TabIndex        =   3
      Top             =   60
      Width           =   2535
   End
   Begin VB.DirListBox DirBox 
      Height          =   3180
      Left            =   6840
      TabIndex        =   2
      Top             =   60
      Width           =   2415
   End
   Begin VB.PictureBox Pic_Show 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      ClipControls    =   0   'False
      FillStyle       =   0  'Solid
      Height          =   3555
      Left            =   60
      ScaleHeight     =   237
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   277
      TabIndex        =   1
      Top             =   60
      Width           =   4155
   End
   Begin VB.CommandButton Btn_Exit 
      Caption         =   "E&xit"
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   400
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   6300
      TabIndex        =   0
      Top             =   3300
      Width           =   1035
   End
   Begin MSComDlg.CommonDialog CMD_Save 
      Left            =   240
      Top             =   4080
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
   End
   Begin VB.Label Lbl_Output 
      Height          =   255
      Left            =   780
      TabIndex        =   6
      Top             =   3720
      Width           =   8415
   End
   Begin VB.Label Lbl_Status 
      BackStyle       =   0  'Transparent
      Caption         =   "Status:"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   3720
      Width           =   675
   End
   Begin VB.Menu M_Options 
      Caption         =   "&Options"
      Begin VB.Menu M_SaveQuality 
         Caption         =   "Quality for saving and language"
      End
      Begin VB.Menu M_Dummy1 
         Caption         =   "-"
      End
      Begin VB.Menu M_About 
         Caption         =   "About PictureView"
      End
      Begin VB.Menu M_Dummy2 
         Caption         =   "-"
      End
      Begin VB.Menu M_Exit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "Frm_View"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Rem ===========================================================================
Rem == Declaresection for use of DLL-Routins.                                ==
Rem ===========================================================================

Option Explicit


Rem ===========================================================================
Rem == At last some global Variables for further use.                        ==
Rem ===========================================================================

Dim X_Width As Integer
Dim X_Height As Integer
Dim X_ShadowDC As Long
Dim X_OrgWidth As Integer
Dim X_OrgHeight As Integer
Rem ===========================================================================
Rem == I think you would end this program. Here it is.                       ==
Rem ===========================================================================
'
Private Sub Btn_Exit_Click()
    Dim X_Success As Long

    X_Success = DeleteDC(X_ShadowDC)
    End
End Sub

Rem ===========================================================================
Rem == Here you can delete a file.                                           ==
Rem ===========================================================================
'
Private Sub Btn_Delete_Click()
    Dim X_I As Integer
    
    X_I = FileBox.ListIndex
    Kill DirBox & IIf((InStr(DirBox, "\") = Len(DirBox)), "", "\") & FileBox
    FileBox.Refresh
    If X_I > FileBox.ListCount - 1 Then
        FileBox.ListIndex = FileBox.ListCount - 1
    Else
        FileBox.ListIndex = X_I
    End If
    FileBox.SetFocus
End Sub

Rem ===========================================================================
Rem == here you can save a picture under another name or convert it to jpg.  ==
Rem ===========================================================================
'
Private Sub Btn_SaveAs_Click()
    Dim X_Extension As String
    Dim X_Succes As Long

    If X_ShadowDC = 0 Then
        Exit Sub
    End If

    CMD_Save.DialogTitle = "Save actual Picture as"
    CMD_Save.DefaultExt = "jpg"
    CMD_Save.Filter = "*.jpg"
    CMD_Save.Flags = &H8000 Or &H2 Or &H4
    CMD_Save.CancelError = True
    CMD_Save.FileName = ""
    On Error Resume Next

    CMD_Save.Action = 2

    If Err Then
        On Error GoTo 0
        Exit Sub
    End If

    X_Extension = Right$(FileBox, 3)

    Select Case UCase$(X_Extension)
    Case "PCX", "GIF"
        On Error GoTo Not_Posible
        SavePicture Pic_Show.Image, "~TMP.BMP"
        X_Succes = NViewLibLoad("~TMP.BMP", 0)
        X_Succes = NViewLibSaveAsJPG(X_SaveQuality, CMD_Save.FileName)
        Kill "~TMP.BMP"

Not_Posible:
    Case Else
        X_Succes = NViewLibSaveAsJPG(X_SaveQuality, CMD_Save.FileName)
    
    End Select
    FileBox.Refresh
End Sub

Rem ===========================================================================
Rem == manual synchronisation whenn you click on the Dir-Box                 ==
Rem ===========================================================================
'
Private Sub DirBox_Change()
    FileBox.Path = DirBox.Path
End Sub

Rem ===========================================================================
Rem == manual synchronisation if you click on the DriveBox.                  ==
Rem ===========================================================================
'
Private Sub DriveBox_Change()
    FileBox.Path = DriveBox.Drive
    DirBox.Path = DriveBox.Drive
End Sub

Rem ===========================================================================
Rem == You have clicked on an entry in the filebox ore moved with your cursor==
Rem == through the filebox. preview the picture.                             ==
Rem ===========================================================================
'
Private Sub FileBox_Click()
    Dim X_Success As Long

    X_Success = DeleteDC(X_ShadowDC)
    Pic_Show.Picture = LoadPicture()
    X_ShadowDC = CreateCompatibleDC(Pic_Show.hdc)
    Call Display_Picture(DirBox & IIf((InStr(DirBox, "\") = Len(DirBox)), "", "\") & FileBox, True)
End Sub


Rem ===========================================================================
Rem == If the Form is loaded initialise some Variables and set properties    ==
Rem == for some controls.                                                    ==
Rem == although center the frame in the middle of the screen.                ==
Rem ===========================================================================
'
Private Sub Form_Load()
    Dim X_Success As Long

    X_Width = Frm_View.ScaleWidth
    X_Height = Frm_View.ScaleHeight
    X_OrgWidth = Frm_View.Width
    X_OrgHeight = Frm_View.Height
    FileBox.Pattern = "*.jpg;*.jif;*.gif;*.bmp;*.dib;*.rle;*.tga;*.pcx;*.jpeg"
    Frm_View.Move (Screen.Width - Frm_View.Width) / 2, (Screen.Height - Frm_View.Height) / 2
    X_SaveQuality = GetSetting("PicView", "Global", "SaveQuality", 70)
    X_Success = NViewLibSetLanguage(GetSetting("PicView", "Global", "Language", "English"))
End Sub

Rem ========================================================================================
Rem == General procedure to show pictures in an control.                                  ==
Rem ========================================================================================
'
Private Sub Display_Picture(X_Picture As String, X_Flag As Boolean)
    Dim X_LoadStatus As Long
    Dim X_SelectedObject As Long
    Dim X_Success As Long

    Dim X_FaktorX As Double
    Dim X_FaktorY As Double

    Dim X_PicLeft As Integer
    Dim X_PicTop As Integer
    Dim X_PicWidth As Integer
    Dim X_PicHeight As Integer

    Dim X_Width As Integer
    Dim X_Height As Integer

    Rem ====================================================================================
    Rem == Protect source against runtime-error.                                          ==
    Rem ====================================================================================

    On Error GoTo LoadError

    Rem ====================================================================================
    Rem == Load the picture and get dimensioninformation about it.                        ==
    Rem ====================================================================================

    X_LoadStatus = NViewLibLoad(X_Picture, 0)

    If X_LoadStatus = 0 Then
        GoTo LoadError
    End If

    X_Width = GetWidth()
    X_Height = GetHeight()

    Rem ====================================================================================
    Rem == Now calculate the stretchdimensions to view picture in picturebox.             ==
    Rem ====================================================================================

    X_FaktorX = Pic_Show.ScaleWidth / X_Width
    X_FaktorY = Pic_Show.ScaleHeight / X_Height

    X_PicHeight = (X_Height * X_FaktorY)
    X_PicWidth = (X_Width * X_FaktorY)
    X_PicLeft = (Pic_Show.Width - X_PicWidth) / 2
    X_PicTop = (Pic_Show.Height - X_PicHeight) / 2

    Rem ====================================================================================
    Rem == and last but not least do the rest to show the picture.                        ==
    Rem ====================================================================================

    X_SelectedObject = SelectObject(X_ShadowDC, X_LoadStatus)
    X_Success = StretchBlt(Pic_Show.hdc, X_PicLeft, X_PicTop, X_PicWidth, X_PicHeight, _
                           X_ShadowDC, 0, 0, X_Width, X_Height, SRCCOPY)
    X_Success = SelectObject(X_ShadowDC, X_SelectedObject)
    X_Success = DeleteObject(X_SelectedObject)
    Pic_Show.Refresh
    Pic_Show.Picture = Pic_Show.Image
    Lbl_Output.Caption = X_Picture & " loaded successfully . . ."
    On Error GoTo 0
    Exit Sub

LoadError:

    Rem ====================================================================================
    Rem == an error occured during the procedure. show message on bottom.                 ==
    Rem ====================================================================================

    Lbl_Output.Caption = "Error during load of picture . . ."
    On Error GoTo 0
End Sub


Rem ========================================================================================
Rem == if you resize your form it will be the best to resize the picture.                 ==
Rem ========================================================================================
'
Private Sub Form_Resize()
    Dim X_FaktorX As Single
    Dim X_FaktorY As Single
    
    Rem ====================================================================================
    Rem == check it it's necessary to redraw the picture.                                 ==
    Rem ====================================================================================

    If Frm_View.WindowState = 1 Then
        Exit Sub
    End If

    If Frm_View.Height < X_OrgHeight Or Frm_View.Width < X_OrgWidth Then
        Exit Sub
    End If

    Rem ====================================================================================
    Rem == calculate new dimensions and replace Controls.                                 ==
    Rem ====================================================================================

    X_FaktorX = Frm_View.ScaleWidth / X_Width
    X_FaktorY = Frm_View.ScaleHeight / X_Height
    
    DirBox.Move Frm_View.ScaleWidth - DirBox.Width
    FileBox.Move DirBox.Left - FileBox.Width

    Btn_SaveAs.Move DirBox.Left + DirBox.Width - Btn_SaveAs.Width
    Btn_Delete.Move Btn_SaveAs.Left - Btn_Delete.Width
    Btn_Exit.Move Btn_Delete.Left - Btn_Exit.Width
    
    DriveBox.Move FileBox.Left
    Pic_Show.Move Pic_Show.Left, Pic_Show.Top, FileBox.Left, Pic_Show.Height * X_FaktorY
    Lbl_Status.Move Lbl_Status.Left * X_FaktorX, Lbl_Status.Top * X_FaktorY
    Lbl_Output.Move Lbl_Output.Left * X_FaktorX, Lbl_Output.Top * X_FaktorY

    X_Width = Frm_View.ScaleWidth
    X_Height = Frm_View.ScaleHeight
    
    Rem ====================================================================================
    Rem == now call procedure to display picture.                                         ==
    Rem ====================================================================================

    Pic_Show.Picture = LoadPicture()
    If FileBox <> "" Then
        Call Display_Picture(DirBox & "\" & FileBox, True)
    End If
End Sub


Rem ========================================================================================
Rem == you can exit a frame by different ways. here if you click on Framecontrols         ==
Rem ========================================================================================
'
Private Sub Form_Unload(Cancel As Integer)
    Dim X_Success As Long

    X_Success = DeleteDC(X_ShadowDC)
End Sub

Rem ===========================================================================
Rem == show something about this programm.                                   ==
Rem ===========================================================================
'
Private Sub M_About_Click()
    Frm_About.Show vbModal
End Sub

Rem ========================================================================================
Rem == if you click in the menu "Save Quality" open another frame.                        ==
Rem ========================================================================================
'
Private Sub M_SaveQuality_Click()
    Frm_Quality.Show vbModal
End Sub

Rem ========================================================================================
Rem == by doubleclick on the picture cut it to clipboard.                                 ==
Rem ========================================================================================
'
Private Sub Pic_Show_DblClick()
    Clipboard.SetData Pic_Show.Picture
End Sub


